#!/usr/bin/perl -w
#
# $Id: life.pl,v 1.5 2003/12/27 02:52:06 shaper Exp $
#
# A simple Perl script that takes as input a user's birthday and life
# expectancy in years and outputs the percentage of their life that has
# elapsed.
#
# 2003/12/01 - Walter Korman (shaper@waywardgeeks.org)
#

use POSIX qw(mktime);

my $usage = "$0: <birthday: MM/DD/YYYY> <lifeInYears: 70>\n";
die $usage unless ($#ARGV >= 1);

$dpy = 365;
$spd = 86400;
($bm, $bd, $by) = split(/\//, $ARGV[0]);

$ls = $ARGV[1] * $dpy * $spd;
if (($edy = 1970 - $by) > 0) {
    $eds = ($edy * $dpy * $spd);

} else {
    $edy = 0;
    $eds = 0;
}

$bs = mktime(0, 0, 0, $bd, $bm - 1, $by + $edy - 1900, 0, 0, 0);

$ts = time() + $eds;
$as = $ts - $bs;

$le = ($ls <= 0) ? 0 : ($as / $ls);
$le = ($le > 1.0) ? 1.0 : $le;

printf("%0.7f%%\n", ($le * 100.0));
